using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GridDoubleClickEdit
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.DisplayLayout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Extended;
            ultraGrid1.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.CellSelect;
            ultraGrid1.DoubleClickCell += new Infragistics.Win.UltraWinGrid.DoubleClickCellEventHandler(ultraGrid1_DoubleClickCell);
            ultraGrid1.InitializeLayout += new Infragistics.Win.UltraWinGrid.InitializeLayoutEventHandler(ultraGrid1_InitializeLayout);
            //ultraGrid1.BeforeSelectChange += new Infragistics.Win.UltraWinGrid.BeforeSelectChangeEventHandler(ultraGrid1_BeforeSelectChange);
            //ultraGrid1.AfterSelectChange += new Infragistics.Win.UltraWinGrid.AfterSelectChangeEventHandler(ultraGrid1_AfterSelectChange);
            ultraGrid1.AfterEnterEditMode += new EventHandler(ultraGrid1_AfterEnterEditMode);
            ultraGrid1.AfterExitEditMode += new EventHandler(ultraGrid1_AfterExitEditMode);

            DataTable table = new DataTable();
            table.Columns.Add("Number", typeof(double));
            table.Columns.Add("DateTime", typeof(DateTime));
            table.Columns.Add("Number (no style)", typeof(double));
            table.Columns.Add("DateTime (no style)", typeof(DateTime));
            table.Columns.Add("Text", typeof(string));

            for (int i = 0; i < 10; i++)
            {
                table.LoadDataRow(new object[] { i, DateTime.Now.AddDays(i), i, DateTime.Now.AddDays(i), "string" + i }, LoadOption.OverwriteChanges);
            }

            ultraGrid1.DataSource = table;
        }

        void ultraGrid1_AfterEnterEditMode(object sender, EventArgs e)
        {
            System.Console.WriteLine("+++++++++++++++++++++++++++++++++++++++++++++++");
            System.Console.WriteLine("Entered EditMode");
        }

        void ultraGrid1_AfterExitEditMode(object sender, EventArgs e)
        {
            System.Console.WriteLine("+++++++++++++++++++++++++++++++++++++++++++++++");
            System.Console.WriteLine("Exites EditMode");
        }

        void ultraGrid1_AfterSelectChange(object sender, Infragistics.Win.UltraWinGrid.AfterSelectChangeEventArgs e)
        {
            System.Console.WriteLine("+++++++++++++++++++++++++++++++++++++++++++++++");
            System.Console.WriteLine("Entering AfterSelect");
        }

        void ultraGrid1_BeforeSelectChange(object sender, Infragistics.Win.UltraWinGrid.BeforeSelectChangeEventArgs e)
        {
            System.Console.WriteLine("================================================");
            System.Console.WriteLine("Entering BeforeSelect");
            System.Console.WriteLine("Cell Selection count: " + e.NewSelections.Rows.Count);
            System.Console.WriteLine("Row Selection count: " + e.NewSelections.Rows.Count);
            System.Console.WriteLine("Type: " + e.Type.ToString());
            System.Console.WriteLine("Leaving BeforeSelect");
        }

        void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Double;
            e.Layout.Bands[0].Columns[0].Format = "N4";

            e.Layout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Date;
            e.Layout.Bands[0].Columns[1].Format = "MM/dd/yyyy";

            e.Layout.Bands[0].Columns[2].Format = "N4";

            e.Layout.Bands[0].Columns[3].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Edit; // comment this out and behaves the same as col 1.
            e.Layout.Bands[0].Columns[3].Format = "MM/dd/yyyy";
        }

        void ultraGrid1_DoubleClickCell(object sender, Infragistics.Win.UltraWinGrid.DoubleClickCellEventArgs e)
        {
            if (e.Cell.IsInEditMode)
                return;

            ultraGrid1.ActiveCell = e.Cell;
            ultraGrid1.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.EnterEditMode);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
                ultraGrid1.DisplayLayout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Extended;
            else
                ultraGrid1.DisplayLayout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Single;
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked)
                ultraGrid1.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
            else
                ultraGrid1.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.CellSelect;
        }
    }
}